<?php

namespace Schaffen\Core\Traits;

use Carbon\Carbon;

trait Audit {
    public function save(array $options = []) {       
        $created_by_field = defined('self::CREATED_BY') && !empty(self::CREATED_BY) ? self::CREATED_BY : 'created_by';
        $created_at_field = defined('self::CREATED_AT') && !empty(self::CREATED_AT) ? self::CREATED_AT : 'created_at';
        $updated_at_field = defined('self::UPDATED_AT') && !empty(self::UPDATED_AT) ? self::UPDATED_AT : 'updated_at';
        $updated_by_field = defined('self::UPDATED_BY') && !empty(self::UPDATED_BY) ? self::UPDATED_BY : 'updated_by';

        $time_field = empty($this->attributes[$created_at_field]) ? $created_at_field : $updated_at_field;
        $user_field = empty($this->attributes[$created_at_field]) ? $created_by_field : $updated_by_field;

        $this->attributes[$time_field] = Carbon::now()->format('Y-m-d H:i:s');
        $this->attributes[$user_field] = auth()->user()->usu_nome;

        parent::save($options);
    }
}